Dynamic Programming | Set 33 (Find if a string is interleaved of two other strings) | GeeksforGeeks


Dynamic Programming | Set 33 (Find if a string is interleaved of two other strings) | GeeksforGeeks
Given three strings A, B and C. Write a function that checks whether C is an interleaving of A and B. C is said to be interleaving A and B, if it contains all characters of A and B and order of all characters in individual strings is preserved.

Dynamic Programming
we can solve it by creating a table and store results of subproblems in bottom up manner.
http://n00tc0d3r.blogspot.com/2013/03/interleaving-string-gene-matching.html
Construct a (n1+1)*(n2+1) table, A[0 .. n1][0 .. n2], where n1 and n2 is the length of s1 and s2, respectively.
A[i][j] = true, i.e. s3[0 .. i+j-1] is an interleaving of s1[0 .. i-1] and s2[0 .. j-1].
Thus, A[n1][n2] represents whether s3 is a interleaving of s1 and s2.
To build up such a table,
  1. Set A[0][0] = true. Period.
  2. Initialize the first row. The first row means whether s1[0 .. (n1-1)] matches s3[0 .. (n1-1)], correspondingly.
  3. Similarly, initialize the first column which means whether s2[0 .. (n2-1)] matchess3[0 .. (n2-1)], correspondingly.
  4. Now we fill up the table. For A[i][j]s3[0 .. (i+j-1)] match? s1[0 .. i-1] weaving s2[0 .. j-1]
    • Note that A[i-1][j] comes from s1[0 .. i-2] weaving s2[0 .. j-1]. Thus, if it is true, we need to compare s1[i-1] with s3[i+j-1].
    • Similarly, A[i][j-1] comes from s1[0 .. i-1] weaving s2[0 .. j-2]. Thus, if it is true, compare s2[j-1] with s3[i+j-1].
  5. Return A[n1][n2]
public boolean isInterleave(String s1, String s2, String s3) {  
   int n1=s1.length(), n2=s2.length(), n3=s3.length();  
   if (n1 + n2 != n3) return false;  
   boolean[][] match = new boolean[n1+1][n2+1];  
   // initialize the first row and first column  
   match[0][0] = true;  
   for (int i=0; i<n1; ++i) {  
     match[i+1][0] = (s1.charAt(i) == s3.charAt(i));  
   }  
   for (int i=0; i<n2; ++i) {  
     match[0][i+1] = (s2.charAt(i) == s3.charAt(i));  
   }  
   // fill up the table  
   for (int i=0; i<n1; ++i) {  
     for (int j=0; j<n2; ++j) {  
       if ((match[i][j+1] && s3.charAt(i+j+1)==s1.charAt(i))  
           || (match[i+1][j] && s3.charAt(i+j+1)==s2.charAt(j))) {  
         match[i+1][j+1] = true;  
       }  
     }  
   }  
   return match[n1][n2];  
 }  
Space Optimization:
Notice that for each A[i][j], we only need A[i-1][j] and A[i][j-1]. So, we can improve the above algorithm with an 1D array. By doing that, the space of the new algorithm get down to O(min(n1, n2)).
 public boolean isInterleave(String s1, String s2, String s3) {  
   int n1=s1.length(), n2=s2.length(), n3=s3.length();  
   if (n1 + n2 != n3) return false;  
   // switch to save space if needed  
   if (n1<n2) {  
     String tmp = s1; s1 = s2; s2 = tmp;  
     n1 = s1.length(); n2 = s2.length();  
   }  
   boolean[] match = new boolean[n2+1];  
   // initialize the first row and first column  
   match[0] = true;  
   for (int j=0; j<n2; ++j) {  
     match[j+1] = (match[j] && s2.charAt(j)==s3.charAt(j));  
     if (!match[j+1]) break;  
   }  
   // fill up the table  
   for (int i=1; i<=n1; ++i) {  
     match[0] = (match[0] && s1.charAt(i-1)==s3.charAt(i-1));  
     for (int j=1; j<=n2; ++j) {  
       match[j] = (match[j] && s3.charAt(i+j-1)==s1.charAt(i-1))  
             || (match[j-1] && s3.charAt(i+j-1)==s2.charAt(j-1));  
     }  
   }  
   return match[n2];  
 }
Find if a string is formed by interleaving two strings - PrismoSkills
It's better to handle base cases out specially, out of loop: better performance, easier to figure out all base cases.
boolean isInterleaved(String A, String B, String C)
{
    int M = A.length();
    int N = B.length();
 
    if ((M+N) != C.length())
       return false;
 
    // lookup[i][j] is true if C[0..i+j-1] is an interleaving of A[0..i-1] and B[0..j-1].
    boolean lookup[][] = new boolean[M+1][N+1];
    for (int i=0; i<=M; i++)
    {
        for (int j=0; j<=N; j++)
        {
            // If both A and B are empty, then C must also be empty (due to length matching)
            // And since one empty string is interleaving of other two empty
            // strings, lookup[0][0] is true.
            if (i==0 && j==0)
                lookup[i][j] = true;
 
            // If A is empty, check one-to-one match with B
            else if (i==0 && B[j-1]==C[j-1])
                lookup[i][j] = lookup[i][j-1];
 
            // If B is empty, check one-to-one match with A
            else if (j==0 && A[i-1]==C[i-1])
                lookup[i][j] = lookup[i-1][j];
 
 
            // Regular check for interleaving
 
            if (A[i-1]==C[i+j-1] && B[j-1]==C[i+j-1])
                lookup[i][j]=(lookup[i-1][j] || lookup[i][j-1]);
 
            else if(A[i-1]==C[i+j-1])
                lookup[i][j] = lookup[i-1][j];
 
            else if (B[j-1]==C[i+j-1])
                lookup[i][j] = lookup[i][j-1];
 
            // Its too soon to return a false if C[i+j-1] matches neither A or B.
            // Think why?
        }
    }
 
    return lookup[M][N];
}

bool isInterleaved(char* A, char* B, char* C)
{
    // Find lengths of the two strings
    int M = strlen(A), N = strlen(B);
    // Let us create a 2D table to store solutions of
    // subproblems.  C[i][j] will be true if C[0..i+j-1]
    // is an interleaving of A[0..i-1] and B[0..j-1].
    bool IL[M+1][N+1];
    memset(IL, 0, sizeof(IL)); // Initialize all values as false.
    // C can be an interleaving of A and B only of sum
    // of lengths of A & B is equal to length of C.
    if ((M+N) != strlen(C))
       return false;
    // Process all characters of A and B
    for (int i=0; i<=M; ++i)
    {
        for (int j=0; j<=N; ++j)
        {
            // two empty strings have an empty string
            // as interleaving
            if (i==0 && j==0)
                IL[i][j] = true;
            // A is empty
            else if (i==0 && B[j-1]==C[j-1])
                IL[i][j] = IL[i][j-1];
            // B is empty
            else if (j==0 && A[i-1]==C[i-1])
                IL[i][j] = IL[i-1][j];
            // Current character of C matches with current character of A,
            // but doesn't match with current character of B
            else if(A[i-1]==C[i+j-1] && B[j-1]!=C[i+j-1])
                IL[i][j] = IL[i-1][j];
            // Current character of C matches with current character of B,
            // but doesn't match with current character of A
            else if (A[i-1]!=C[i+j-1] && B[j-1]==C[i+j-1])
                IL[i][j] = IL[i][j-1];
            // Current character of C matches with that of both A and B
            else if (A[i-1]==C[i+j-1] && B[j-1]==C[i+j-1])
                IL[i][j]=(IL[i-1][j] || IL[i][j-1]) ;
        }
    }
    return IL[M][N];
}
The worst case time complexity of recursive solution is O(2n).
a) If first character of C matches with first character of A, we move one character ahead in A and C and recursively check.
b) If first character of C matches with first character of B, we move one character ahead in B and C and recursively check.'
  • Test a character in s1, s1[i]==s3[k]?, if succeeded, move s1 and s3 to next character, and then test the rest of s3 with the rest of s1 and s2;
  • Or test a character in s2, s2[j]==s3[k]?, if succeeded, move s2 and s3 to next character, and then test the rest of s3 with the rest of s1 and s2.
a) If first character of C matches with first character of A, we move one character ahead in A and C and recursively check.
b) If first character of C matches with first character of B, we move one character ahead in B and C and recursively check.
 private boolean helper(char[] s1, int n1, char[] s2, int n2, char[] s3, int n3) {  
   if (n1==s1.length && n2==s2.length && n3==s3.length) return true;  
   if (n1==s1.length) return (s2[n2]==s3[n3] && helper(s1, n1, s2, n2+1, s3, n3+1));  
   if (n2==s2.length) return (s1[n1]==s3[n3] && helper(s1, n1+1, s2, n2, s3, n3+1));  
   return (s1[n1]==s3[n3] && helper(s1, n1+1, s2, n2, s3, n3+1))  
       || (s2[n2]==s3[n3] && helper(s1, n1, s2, n2+1, s3, n3+1));  
 }  
   
 public boolean isInterleave(String s1, String s2, String s3) {  
   if (s1.length() + s2.length() != s3.length()) return false;  
   return helper(s1.toCharArray(), 0, s2.toCharArray(), 0, s3.toCharArray(), 0);  
 } 
Cleaner:
    private static boolean isInterleaved
    (
        String s1, String s2, String s, 
        int pos1, int pos2, int pos
    ) {
        if (pos >= s.length())
            return true;
        
        boolean match1 = false;
        boolean match2 = false;
        
        if (pos1 < s1.length())
            match1 = (s.charAt(pos) == s1.charAt(pos1));
        
        if (pos2 < s2.length())
            match2 = (s.charAt(pos) == s2.charAt(pos2));
        
        return (
                (match1 && isInterleaved (s1, s2, s, pos1+1, pos2, pos+1)) ||
                (match2 && isInterleaved (s1, s2, s, pos1, pos2+1, pos+1))
            );
        
    }

bool isInterleaved(char *A, char *B, char *C)
{
    // Base Case: If all strings are empty
    if (!(*A || *B || *C))
        return true;
    // If C is empty and any of the two strings is not empty
    if (*C == '\0')
        return false;
    // If any of the above mentioned two possibilities is true,
    // then return true, otherwise false
    return ( (*C == *A) && isInterleaved(A+1, B, C+1))
           || ((*C == *B) && isInterleaved(A, B+1, C+1));
}

Read full article from Dynamic Programming | Set 33 (Find if a string is interleaved of two other strings) | GeeksforGeeks

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts